var isBB10 = false;
var isGEO = true;
var isLeague = true;
var isPush = false;
var latitude = "%lat%";
var longitude = "%lon%";
var accuracy = "%acc%";
var frenchMessages = {};
frenchMessages["ENABLE_PUSH"] = "La notification pousse, utilise les don\xE9es et peut co\xFBter plus quand tu vague.  S'il vous pla\xEEt, verifie avec ton compagnie de t\xE9l\xE9phone pour les prix des don\xE9es.\n\n  Est-ce que tu veux les notifications?";
frenchMessages["DISABLE_PUSH"] = "Est-ce que tu veux \xE9teindre les notifications?";
frenchMessages["PUSH_SETTINGS"] = "Param\xE8tres de notification";
var englishMessages = {};
englishMessages["ENABLE_PUSH"] = "Push notification uses data and may cost more when roaming.  Please check with your carrier for data pricing.\n\nDo you wish to enable notifications?";
englishMessages["DISABLE_PUSH"] = "Do you wish to disable notifications?";
englishMessages["PUSH_SETTINGS"] = "Push Settings";
function getLocalizedMessage(key) {
    var message;
    if (getLanguage() == "fr") {
        message = frenchMessages[key];
    } else {
        message = englishMessages[key];
    }
    return message;
}
var backButtonList = [];
var doScroll = false;
String.prototype.hashCode = function() {
    var hash = 0, i, char;
    if (this.length == 0)
        return hash;
    for (i = 0; i < this.length; i++) {
        char = this.charCodeAt(i);
        hash = ((hash << 5) - hash) + char;
        hash = hash & hash; // Convert to 32bit integer
    }
    return hash;
};
var urlResults = {};
// Some Memory Clean up
var clones = [];
function cloneNodeOverride(element) {
    var clone = element.cloneNode(true);
    clones.push(clone);
    return clone;
}
function deleteAllAttributes() {
    var all = document.getElementsByTagName("*");
    for (var i = 0, max = all.length; i < max; i++) {
        var element = all[i];
        for (var index = 0; index < element.attributes.length; index++) {
            element.attributes[index] = null;
        }
    }
}
function deleteOrphenClones() {
    var orphenCount = 0;
    for (var cloneIndex = 0; cloneIndex < clones.length; cloneIndex++) {
        try {
            var clone = clones[cloneIndex];
            if (clone.parentNode == null) {
                for (var index = 0; index < clone.attributes.length; index++) {
                    clone.attributes[index] = null;
                }
                clones[cloneIndex] = null;
                orphenCount++;
            }
            clone = null;
        } catch (e) {
        }
    }
    var nullIndex = clones.indexOf(null);
    while (nullIndex != -1) {
        clones.splice(nullIndex, 1);
        nullIndex = clones.indexOf(null);
    }
    // alert("Deleted :" + orphenCount + " Clones:" + clones.length);
}
function deleteClones() {
    for (var cloneIndex = 0; cloneIndex < clones.length; cloneIndex++) {
        try {
            var clone = clones[cloneIndex];
            for (var index = 0; index < clone.attributes.length; index++) {
                clone.attributes[index] = null;
            }
            clone.parentNode.removeChild(clone);
            clones[cloneIndex] = null;
        } catch (e) {
        }
    }
    clones = [];
}
function isBlank(str) {
    return (!str || /^\s*$/.test(str));
}
var ajaxSuccess = 0;
var ajaxFail = 0;
function loadxml(url, interval, async) {
    url += appIdtrailer;
    url = url.replace("%selectedCellRowId%", lastRowId);
    // console.log(url);
    if (url.indexOf("search=%TeamsSearchText_Temp%") != -1) {
        var searchInput = document.getElementById("TextBox_Search_Clear");
        var searchTerm = "";
        if (searchInput != null && !isBlank(searchInput.value)) {
            searchTerm = "search=" + searchInput.value;
        }
        url = url.replace("search=%TeamsSearchText_Temp%", searchTerm);
    }
    var noCache = false;
    if (typeof async == 'undefined') {
        async = true;
    }
    var noCache = false;
    if (interval != 0 || loadedContent[url] == null || noCache) {
        loadedContent[url] = true;
        url = url.replace("after=", "ifChangedSince=");
        if (interval <= 0) {
            url = url.replace("%newestCellDate%", "01-01-2010");
            url = url.replace("%lastUpdatedDate%", "01-01-2010");
        } else {
            delete lastDate;
            lastDate = calcTime(-4);
            url = url.replace("%newestCellDate%", lastDate.formatDate("yyyy-MM-dd HH:mm"));
            url = url.replace("%lastUpdatedDate%", lastDate.formatDate("yyyy-MM-dd HH:mm"));
        }
        if (hasDataCoverage()) {
            var randomnumber = Math.floor(Math.random() * 1000001);
            var starttime;
            var endtime;
            if (url.indexOf("%lon%") > 0) {
                url = url.replace("%lon%", longitude);
            }
            if (url.indexOf("%lat%") > 0) {
                url = url.replace("%lat%", latitude);
            }
            if (url.indexOf("%acc%") > 0) {
                url = url.replace("%acc%", accuracy);
            }
            $.ajax({
                type : "GET",
                'url' : url + "&r=" + randomnumber,
                dataType : "text",
                async : async,
                success : function(result) {
                    if (result.indexOf("<result>Error</result>") != -1) {
                        // TODO: something else here not alerts
                    } else if (interval > 0) {
                        ajaxSuccess++;
                        // TODO: only update template if xml has changed
                        var trimIndex = url.indexOf("ifChangedSince");
                        if (trimIndex == -1) {
                            trimIndex = url.length;
                        }
                        // console.log(url.substring(0, trimIndex));
                        var urlHash = "hash" + url.substring(0, trimIndex).hashCode();
                        var resultHash = "hash" + result.substring(58).hashCode();
                        runUupdateTemplate = true;
                        if (urlResults[urlHash] == undefined) {
                            urlResults[urlHash] = result.hashCode();
                            // console.log("Added: ", url);
                        } else if (urlResults[urlHash] != resultHash) {
                            urlResults[urlHash] = resultHash;
                            // console.log("Updating: ", url);
                        } else {
                            runUupdateTemplate = false;
                            // console.log("No Update: ", url);
                        }
                        if (runUupdateTemplate) {
                            updateTemplate(result, url, interval);
                            updateFrenchContent();
                        }
                    } else {
                        updateTemplate(result, url, interval);
                        updateFrenchContent();
                    }
                },
                error : function(xhr, ajaxOptions, thrownError) {
                    ajaxFail++;
                    // console.log(new Date(), "AJAX FAILED: ", ajaxFail, " URL:
                    // ", url);
                    // TODO: defer, not cancel if it is a one time only
                    // thing....
                },
                beforeSend : function() {
                    starttime = new Date().getTime();
                    $('body').css('cursor', 'wait');
                },
                complete : function(jqXHR, textStatus) {
                    endtime = new Date().getTime();
                    $('body').css('cursor', 'default');
                    // debugOut("AJAX DURATION: " + (endtime - starttime) + "ms
                    // <br/> URL:" + url);
                }
            });
        } else {
            var cachedXml = loadCache(url);
            if (cachedXml != null) {
                updateTemplate(cachedXml, url, interval);
            }
        }
    }
}
function isRequestSuccessful(httpRequest) {
    var success = (httpRequest.status == 0 || (httpRequest.status >= 200 && httpRequest.status < 300) || httpRequest.status == 304 || httpRequest.status == 1223);
    return success;
}
var callbacks = [];
var runningThreads = [];
function startThread(url, interval) {
    if (interval == 20) {
        interval = 180;
    }
    if (interval == 15) {
        interval = 45;
    }
    url = apiUrl + url;
    url = url.replace("%contentPage%", "LineUpLastGame");
    var thread = null;
    var callback = null;
    if (interval <= 0) {
        if (url.indexOf("GetAd") != -1) {
            callback = window.setTimeout("loadxml( '" + url + "'," + nextInt + " );", nextInt);
            nextInt += 500;
        } else {
            callback = window.setTimeout("loadxml( '" + url + "'," + 0 + " );", 0);
        }
    } else {
        callback = window.setTimeout("loadxml( '" + url + "'," + 0 + " );", 0);
        thread = window.setInterval("loadxml( '" + url + "', " + (interval * 1000) + " );", (interval * 1000));
    }
    // callbacks.push(callback);
    runningThreads.push(thread);
}
function startThreadSynchronous(url, interval) {
    if (interval == 20) {
        interval = 180;
    }
    if (interval == 15) {
        interval = 120;
    }
    if (isLeague && subAppId == "") {
        return;
    }
    url = apiUrl + url;
    url = url.replace("%contentPage%", "LineUpLastGame");
    var thread = null;
    if (interval <= 0) {
        loadxml(url, interval, true);
    } else {
        loadxml(url, 0, true);
        thread = window.setInterval("loadxml( '" + url + "', " + (interval * 1000) + ", true );", (interval * 1000));
    }
    runningThreads.push(thread);
}
function loadFromXml(url, fileName) {
    if (subAppId == "") {
        return;
    }
    var key = buildCacheID(url);
    var xmlData = window.localStorage.getItem(key);
    if (xmlData != null) {
        updateTemplate(xmlData, url);
    } else {
        $.ajax({
            type : "GET",
            'url' : fileName,
            contentType : 'application/xml',
            dataType : "text",
            success : function(result) {
                if (window.localStorage.getItem(key) == null) {
                    window.localStorage.setItem(key, result);
                }
                updateTemplate(result, url);
            },
            error : function(xhr, ajaxOptions, thrownError) {
            }
        });
    }
}
function buildCacheID(url) {
    url = url.replace(apiUrl, "");
    if (url.indexOf("&") > -1) {
        url = url.substring(0, url.indexOf("&"));
    }
    return "appId" + appId + "~" + url;
}
function cacheXml(url, xml) {
    // TODO: restrict what is cached. could be performance issues.
    if (xml.indexOf("<data></data>") == -1) {
        window.localStorage.setItem(buildCacheID(url), xml);
    }
}
function loadCache(url) {
    return window.localStorage.getItem(buildCacheID(url));
}
var mobileDebugOn = false;
function debugOut(message) {
    try {
        if (mobileDebugOn) {
            if ($("#debugLoggingDiv").length == 0) {
                $("#Panel_Root")
                        .append(
                                "<div id='debugLoggingDiv' style='display:none;z-index:999;width:100%;height:100%;overflow:scroll;background:white;color:black;position:absolute;'></div>");
                document.onkeydown = function(evt) {
                    if (evt.keyCode == 90) {
                        $("#debugLoggingDiv").toggle();
                    }
                };
            }
            $("#debugLoggingDiv").append("<p>" + (new Date()) + " : " + message + "</p>");
        }
    } catch (e) {
        alert(e);
    }
}
if (isBB10) {
    window.addEventListener("load", function(e) {
        document.addEventListener("deviceready", onLoadedOverride, false);
    }, false);
}
function onLoadedOverride() {

    // TODO: may cause issues with non PST apps or League apps.
    // TODO: make this async and then load the urls that need the subAppId on
    // successfull call
    if (appId == 22 || appId == 26) { // hack to solve the issue mentioned above in the TODOs.
        subAppId = cGet(apiUrl + "GetSubAppId.aspx?appId=" + appId, false, null, null);
        appIdtrailer += "&subAppId=" + subAppId;
    }

    document.addEventListener("touchmove", touchMoveHandler, false);

    initPage();
    if (phoneType != null && phoneType != "none") {
        eval("thisPhoneType = buzzerapps.phoneType." + phoneType);
    }
    $("body,html").css("background-color", "black");
    $("#TextBox_Search_Clear").css("border", "none").css("border-color", "transparent");
    $("div[id^=scrollerTable_]").css('overflow', '').addClass("overthrow");
    $("div").removeAttr('ontouchstart', '');
    $("div[id^=Tab_]").css('z-index', '500');
    window.localStorage.setItem("UID" + appId, uuid());
    if (appId != 5000 && appId != 602 && appId != 501 && thisPhoneType == buzzerapps.phoneType.BB_WEB) {
        $("#TableRow_liveMessageTemplateA").remove();
        $("#TableRow_liveMessageTemplateB").remove();
        $("#TableRow_liveMessageTemplateAReply").remove();
        $("#TableRow_liveMessageTemplateBReply").remove();
        $("#Table_LiveMessages").load("common/js/liveTemplateAB.txt");
        $("#Table_LiveMessagesReply").load("common/js/liveTemplateABReply.txt");
    }
    // Twitter only, no clicking through
    if (appId == 501 || isLeague) {
        $("#TableRow_liveMessageTemplateA").removeAttr("ontapped");
        $("#TableRow_liveMessageTemplateB").removeAttr("ontapped");
    }
    if (appId == 10000) {
        $("#Table_CurrentTeams").css({
            left : 0
        });
        $('div#Label_Event').css("height", "auto");
    }
    $("#CheckBox_Dislike").remove();
    $("#CheckBox_Dislike").remove();
    $("#CheckBox_Like").each(function() {
        $(this).width($(this).width() * 2);
        $(this).height($(this).height() * 2);
    });
    if (isBB10) {
        $("div[id^=Label_]").each(function() {
            $(this).css('line-height', $(this).css('font-size'));
        });
        $("#Image_AlertSelect2").remove();
        $("div[id^=CheckBox_AlertSelect2]").remove();
        $("div[id^=tabcontentTab_]").each(function() {
            $(this).css('top', "");
            $(this).css('bottom', "5px");
        });
        /*
         * pushwoosh.register(function(pushObject){ //TODO: do the stuff alert("push: " + JSON.stringify(pushObject)); try { var token =
         * PushWoosh.getToken(); appSync(token); } catch (e) { // alert("appSync" + e); } });
         */
    }
    if (isLeague) {
        // set the back groun image to
        $("#TableRow_ChangeTeamDivision").css("backgroundImage", "url(common/images/teamPickerTeamBack.png)").css("backgroundSize", "100% 100%");
        $("#TableRow_ChangeTeamDivision").children("#Image_Background").css("backgroundImage", "");
        $("#TableRow_ChangeTeamDivision").children("#Image_Background").css("zIndex", "1000");
        $("#TableRow_ChangeTeamDivision").children("#Label_Team").css("zIndex", "999");
        $("#TableRow_Division").css("backgroundImage", "url(common/images/teamPickerTeamBack.png)").css("backgroundSize", "100% 100%");
        $("#TableRow_Division").children("#Image_Background").css("backgroundImage", "");
        $("#TableRow_Division").children("#Image_Background").css("zIndex", "1000");
        $("#TableRow_Division").children("#Label_Team").css("zIndex", "999");
    }
    internationalImages['Image_RegularSeason'] = "local/RegularSeason.png";
    internationalImages['Image_PostSeason'] = "local/PostSeason.png";
    internationalImages['Image_ApplyEmailAddresss'] = "local/applyButton.png";
    if (isLeague) {
        hookupTeamPickerBack();
    }
    preSetup();
    updateAppIdUrlTrailer();
    try {
        lang = getLanguage();
        for ( var key in internationalImages) {
            if (lang == "fr") {
                var imageBlah = $("#" + key);
                imageBlah.css("backgroundImage", "url(" + internationalImages[key].replace("local", "common/images/fr") + ")").css("backgroundSize",
                        "100% 100%");
            } else if (lang == "en") {
                $("#" + key).css("backgroundImage", "url(" + internationalImages[key].replace("local", "common/images") + ")").css("backgroundSize",
                        "100% 100%");
            }
        }
        if (thisPhoneType == buzzerapps.phoneType.BB_TOUCH || thisPhoneType == buzzerapps.phoneType.BB_WEB) {
            fixTemplates();
            setupAdBanner();
        }
        if (appId != 600 && appId != 605 && appId != 601 && !isBB10 && appId != 501) {
            $("#TableRow_Matchups").height(15).css("position", "relative").css("top", "0px").children().height(15);
            $("#TableRow_MatchupsDate").height(15).css("position", "relative").css("top", "0px").children().height(15);
            $("#TableRow_MatchupsSpacer").height(15).css("position", "relative").css("top", "0px").children().height(15);
        }
        $("#Table_LiveMessages").height("");
        // $("div[id^=TableRow_Matchups]").height(15).css("position","relative").css("top","0px");
        $("div[id^=tabcontentTab]").css("top", "").css("bottom", "3");
        $("#Image_CalendarForward").css("zIndex", "100");
        $("#Image_CalendarBack").css("zIndex", "100");
        setUpPushPopUps();
        createBackButtonList();
        if (!hasDataCoverage()) {
            initCacheStorage();
        }
        if (appId == 10000) {
            $("#TableRow_Division div:first").css("backgroundImage", "url(common/images/select_venue_back.png)").css("backgroundSize", "100% 100%")
                    .css("zIndex", "500");
            ;
            $("#TableRow_Division :nth-child(3)").css("backgroundImage", "url(common/images/gps_icon.png)").css("backgroundSize", "100% 100%").css(
                    "zIndex", "501");
            ;
        }
        if (appId == 5000) {
            // TODO: review for android only / touch only code.
            $('div[id^=Tab_]').each(function(index, Element) {
                $(Element).css("zIndex", "9999");
            });
            var baseHeight = $("#contentPanel").height() - $("#Image_Status").height() - $("#Tab_Home").height() - $("#Image_TopBarLive").height();
            $("#scrollerTable_Fashion").height(baseHeight - $("#Label_FeedInfo").height());
            $("#Panel_Schedule").height(baseHeight);
            $("#scrollerTable_Filter").height(baseHeight);
            $("#scrollerTable_Results").height(baseHeight);
            $("#scrollerTable_Login").height(baseHeight + $("#Image_TopBarLive").height());
            $("#Panel_Results").height(baseHeight);
            $("#Panel_Catagories").height(baseHeight + $("#Image_TopBarLive").height());
            $("#Image_Matchups").css("zIndex", "999");
            $("#Image_Matchups")
                    .bind(
                            "click",
                            function() {
                                clickedImageListItem("rtsp://v5.cache2.c.youtube.com/CjYLENy73wIaLQnFUmfkhhtQtxMYJCAkFEIJbXYtZ29vZ2xlSARSBXdhdGNoYIzovfS01NzgUAw=/0/0/0/video.3gp");
                                // http://www.youtube.com/embed/t1AbhuRnUsU?fs=0&rel=0&autoplay=1
                            });
            $("#scrollerTable_HomeBanner,#scrollerTable_HomePopularBuzz,#scrollerTable_ScoreBoard,#Table_Ad1").bind("click", function() {
                this.blur();
                setTabDown("Tab_Standings");
                loadxml("http://api.buzzerapps.com/admin/GetLoginPanel.aspx?a=1", 0);
                openPanel(this, "Panel_Standings", null, false, false, false);
            });
        }
        if (!isLeague) {
            initPageNonLeague();
        } else {
            initPageLeague();
        }
        // remove the prevent default from these input fields that the init page
        // above adds.
        // document.getElementById("tabimageTab_Live").src =
        // "common/images/nav2.png";
        // TODO: slow code do during build
        // updateLoclImagePaths();
        if (!isBB10 && thisPhoneType == buzzerapps.phoneType.BB_TOUCH || thisPhoneType == buzzerapps.phoneType.BB_WEB) {
            try {
                webworks.bbalert.led.flashLED('stop');
            } catch (e) {
                // TODO: handle exception
            }
            blackberry.app.event.onExit(onExitCallback);
            blackberry.app.event.onForeground(onForegroundCallback);
            if (isPush && window.openBISPushListener && isPushAuthorized()) {
                // setUpMessageList();
                setTimeout(function() {
                    debugOut("calling openBISPushListener");
                    openBISPushListener();
                }, 5000);
            }
        } else {
            document.addEventListener("backbutton", getBackButtonScript, false);
            if (isPush) {
                setTimeout(function() {
                    initPushwoosh();
                    navigator.splashscreen.hide();
                }, 2000);
            }
        }
        if (appId == 5000) {
            $("#Panel_Schedule").append("<div id='map_canvas' style='position:absolute;top:50px;left:0px;width:100%;height:100%;'></div>");
        }
    } catch (e) {
        // alert("Error:" + e);
    }
    hookUpdata();
    // TODO: should look for all divs with iframe in the id.
    var iframeDiv = document.getElementById("Iframe_Calculator");
    if (iframeDiv != null) {
        iframeDiv.innerHTML = iframeDiv.outerHTML.replace("<div", "<iframe");
        iframeDiv.innerHTML = iframeDiv.outerHTML.replace("</div", "</iframe");
    }
    /*
     * var iframeDiv = document.getElementById("Iframe_Map"); if (iframeDiv != null) { iframeDiv.innerHTML = iframeDiv.outerHTML.replace("<div", "<iframe");
     * iframeDiv.innerHTML = iframeDiv.outerHTML.replace("</div", "</iframe"); }
     */
    $("#scrollerTable_More").css("backgroundImage", "url(common/images/MoreBack.png)").css("backgroundSize", "");
    if (isPush && (thisPhoneType == buzzerapps.phoneType.BB_TOUCH || thisPhoneType == buzzerapps.phoneType.BB_WEB)) {
        displayLastMessage();
    }
    $("#Image_Status").css("backgroundSize", "100% 100%");
    $("#wrapper").show();
    debugOut("onLoadedOverride end");
    setTimeout(function() {
        executeClickTouch("Tab_Home");
    }, 1);
    if (isGEO) {
        startWatchingGeoPosition();
    }
}
function createBackButtonList() {
    backButtonList = [];
    var images = document.getElementsByTagName("div");
    for (var i = 0; i < images.length; i++) {
        if (images[i].style.backgroundImage.indexOf("black_back_nav.png") > 0) {
            if (lang == "fr") {
                // Update French Images while we are here
                images[i].style.backgroundImage = "url(common/images/fr/black_back_nav.png)";
            } else {
                images[i].style.backgroundImage = "url(common/images/black_back_nav.png)";
            }
            backButtonList.push(images[i]);
        }
    }
}
function getBackButtonScript(event) {
    event.preventDefault();
    event.stopPropagation();
    var exitApp = true;
    var command = "";
    var foundBack = false;
    for (var i = 0; i < backButtonList.length; i++) {
        var location = getOffset(backButtonList[i]);
        var ele = document.elementFromPoint(location.left + 5, location.top + 5);
        if (ele != null && ele.style != null && ele.style.background.indexOf("black_back_nav.png") > 0) {
            foundBack = true;
            break;
        }
    }
    if (foundBack) {
        if (ele.attributes.ontapped) {
            command = ele.attributes.ontapped.value;
            command = command.replace(/this/g, "ele");
            eval(command);
            exitApp = false;
        } else if (ele.attributes.onclick) {
            command = ele.attributes.onclick.value;
            command = command.replace(/this/g, "ele");
            eval(command);
            exitApp = false;
        } else {
            teamPickedBack();
            exitApp = false;
        }
    }
    if (exitApp && document.getElementById("Panel_Home").style.display == "none") {
        executeClickTouch("Tab_Home");
        exitApp = false;
    }
    if (exitApp) {
        // do the exit and clean up
        onExitCallback();
    }
}
function executeClickTouch(tabId) {
    closePanels();
    if (isLeague && subAppId == "" || subAppId == null) {
        if (thisPhoneType == buzzerapps.phoneType.ANDROID) {
            alert("Please make a selection to get started.");
        } else {
            try {
                var buttons = [ "OK" ];
                var ops = {
                    title : "Please make a selection"
                };
                blackberry.ui.dialog.customAskAsync("Please make a selection to get started.", buttons, dialogCallBack, ops);
            } catch (e) {
                alert("Exception in customDialog: " + e);
            }
        }
        return;
    }
    closeForm(null, "Panel_ChangeTeam");
    var tab = document.getElementById(tabId);
    var command;
    if (thisPhoneType == buzzerapps.phoneType.BB_WEB) {
        command = tab.attributes.onclick.value;
    } else {
        command = tab.attributes.ontapped.value;
    }
    command = command.replace(/this/g, tabId);
    eval(command);
}
function dialogCallBack() {
}
function closePanels() {
    closeForm(null, "Panel_PostBuzz");
    closeForm(null, "Panel_Feedback");
}
function hasDataCoverage() {
    var hasCoverage = true;
    try {
        switch (thisPhoneType) {
        case buzzerapps.phoneType.BB_TOUCH:
            hasCoverage = blackberry.system.hasDataCoverage();
            break;
        case buzzerapps.phoneType.BB_WEB:
            hasCoverage = blackberry.system.hasDataCoverage();
            break;
        default:
            hasCoverage = true;
            break;
        }
    } catch (e) {
        hasCoverage = true;
    }
    return hasCoverage;
}
function getOffset(el) {
    var _x = 0;
    var _y = 0;
    while (el && !isNaN(el.offsetLeft) && !isNaN(el.offsetTop)) {
        _x += el.offsetLeft - el.scrollLeft;
        _y += el.offsetTop - el.scrollTop;
        el = el.offsetParent;
    }
    return {
        top : _y,
        left : _x
    };
}
function onExitCallback() {
    deleteAllAttributes();
    deleteClones();
    if (thisPhoneType == buzzerapps.phoneType.BB_TOUCH || thisPhoneType == buzzerapps.phoneType.BB_WEB) {
        blackberry.app.exit();
    } else {
        navigator.app.exitApp();
    }
}
var pushSetupUrl = "NOT SYNCED";
function appSync(pushToken) {
    var params = [];
    params.push();
    params.push("AppSync.aspx?pushAppId=${PUSH_WOOSH_APPLICATION_ID}");
    params.push("deviceid=" + pushToken);
    params.push("appId=" + appId);
    params.push("uid=" + uuid());
    var url = apiUrl + params.join("&");
    $.ajax({
        type : "GET",
        'url' : url,
        contentType : 'application/xml',
        dataType : "text",
        success : function(result) {
            pushSetupUrl = "SUCCESS";
        },
        error : function(xhr, ajaxOptions, thrownError) {
            pushSetupUrl = "FAILED";
        }
    });
}
function setUpPushPopUps() {
    var margin = 20;
    var padding = 20;
    var pushPopup = document.getElementById("pushPopup");
    if (pushPopup != null) {
        pushPopup.style.left = margin / 2 + padding / 2;
        pushPopup.style.width = parseInt(document.getElementById("contentPanel").style.width, 10) - (margin * 2) - (padding * 2);
        var popUpCLoseButton = document.getElementById("popUpCLoseButton");
        if (!thisPhoneType == buzzerapps.phoneType.BB_WEB) {
            popUpCLoseButton.addEventListener("touchstart", hidePushPopup);
        }
        popUpCLoseButton.addEventListener("click", hidePushPopup);
    }
}
function onForegroundCallback() {
    webworks.bbalert.led.flashLED('stop');
    displayLastMessage();
}
function displayPushPopup(itemValue) {
    var message = itemValue;
    if (thisPhoneType == buzzerapps.phoneType.BB_TOUCH || thisPhoneType == buzzerapps.phoneType.BB_WEB) {
        message = itemValue.description;
        $("#pushMessageCountDiv").show();
        var messageList = {};
        if (existsLocal(messsageListStoreKey)) {
            messageList = getLocal(messsageListStoreKey);
        }
        var messageCount = Object.keys(messageList).length;
        var s = messageCount > 1 ? "s" : "";
        $("#pushMessageCountText").text(messageCount + " Message" + s);
        if (messageCount > 1) {
            $("#popUpCLoseButton").addClass("leftButton");
            $("#pushSkipAllButton").show().addClass("rightButton");
        }
        $("#popUpCLoseButton").show();
    }
    var pushPopup = document.getElementById("pushPopup");
    var popUpTextDiv = document.getElementById("popUpTextDiv");
    popUpTextDiv.innerHTML = message;
    pushPopup.style.display = "block";
    pushPopup.messageObject = itemValue;
}
function hidePushPopup() {
    var pushPopup = document.getElementById("pushPopup");
    pushPopup.style.display = "none";
    if (thisPhoneType == buzzerapps.phoneType.BB_TOUCH || thisPhoneType == buzzerapps.phoneType.BB_WEB) {
        deleteMessageItem(pushPopup.messageObject);
        displayLastMessage();
    }
}
function getPushAuthorizedKey() {
    return appId + "_pushAuthorizedKey";
}
function isPushAuthorized() {
    var authorized = false;
    if (thisPhoneType == buzzerapps.phoneType.BB_TOUCH || thisPhoneType == buzzerapps.phoneType.BB_WEB) {
        if (!localStorage[getPushAuthorizedKey()]) {
            localStorage[getPushAuthorizedKey()] = authorized;
        } else {
            authorized = localStorage[getPushAuthorizedKey()];
        }
    }
    return authorized == "true" ? true : false;
}
function pushAuthorized(checkboxElement) {
    if ($(checkboxElement).attr("onTapped").indexOf("type=email") > -1) {
        return true;
    }
    var authorized = isPushAuthorized();
    if (!authorized) {
        authorized = confirm(getLocalizedMessage("ENABLE_PUSH"));
        localStorage[getPushAuthorizedKey()] = authorized;
        if (authorized) {
            // setUpMessageList();
            openBISPushListener();
        }
    }
    updatePushIcon();
    return authorized;
}
function pushAuthorizedToggle() {
    var authorized = isPushAuthorized();
    if (!authorized) {
        authorized = confirm(getLocalizedMessage("ENABLE_PUSH"));
        localStorage[getPushAuthorizedKey()] = authorized;
        if (authorized) {
            // setUpMessageList();
            openBISPushListener();
        }
    } else {
        if (confirm(getLocalizedMessage("DISABLE_PUSH"))) {
            localStorage[getPushAuthorizedKey()] = false;
            cancelSubscription();
        }
    }
    updatePushIcon();
}
function updatePushIcon() {
    if (!isPushAuthorized()) {
        $("#Image_AlertSelect2").html("<img src='common/images/pushnotifyNot.png' />");
    } else {
        $("#Image_AlertSelect2").html("");
    }
}
// @OVERRIDE
function replaceBackImage() {
    // Do not replaceback images, Android and Blackberry do not support this
    // yet. This is to show down button presses.
}
function updateFrenchContent() {
    for ( var key in internationalLabels) {
        var element = document.getElementById(key);
        if (element != null) {
            var elementArray = internationalLabels[key].split("~");
            var eng = elementArray[0];
            var fre = elementArray[1];
            if (elementArray.length > 1) {
                if (lang == "en") {
                    element.innerHTML = eng;
                } else if (lang == "fr") {
                    element.innerHTML = fre;
                }
            }
        }
    }
}
function getLanguage() {
    var lang;
    if (thisPhoneType == buzzerapps.phoneType.BB_TOUCH || thisPhoneType == buzzerapps.phoneType.BB_WEB) {
        if (navigator.language.indexOf("fr") != -1) {
            lang = "fr";
        } else {
            lang = "en";
        }
    } else {
        if (navigator.userAgent.indexOf("fr") != -1) {
            lang = "fr";
        } else {
            lang = "en";
        }
    }
    return lang;
}
function updateLoclImagePaths() {
    // Created this function to deal with the change of using DIV over IMG tags
    var replacePath = "common/images";
    if (lang == "fr") {
        replacePath = "common/images/fr";
    }
    for ( var key in internationalImages) {
        var element = document.getElementById(key);
        if (element != null) {
            if (element.tagName == "IMG") {
                element.src = internationalImages[key].replace("local", replacePath);
            } else {
                var backgroundUrl = "url(" + internationalImages[key].replace("local", replacePath) + ") no-repeat";
                element.style.background = backgroundUrl;
            }
        }
    }
}
function clickDownAnimate(element, popback) {
    var attr = $(element).attr('ontapped');
    if (typeof attr !== 'undefined' && attr !== false && attr.indexOf("setTabDown") != -1) {
        // Do nothing
    } else {
        $(element).css("margin-top", "3px").css("margin-left", "3px");
        if (popback) {
            setTimeout(function() {
                $(element).css("margin-top", "0px").css("margin-left", "0px");
            }, 500);
        }
    }
}
function makeNewElementFromElement(tag, elem) {
    var newElem = document.createElement(tag), i, prop, attr = elem.attributes, attrLen = attr.length;
    // Copy children
    elem = elem.cloneNode(true);
    while (elem.firstChild) {
        newElem.appendChild(elem.firstChild);
    }
    // Copy DOM properties
    for (i in elem) {
        try {
            prop = elem[i];
            if (prop && i !== 'outerHTML' && (typeof prop === 'string' || typeof prop === 'number')) {
                newElem[i] = elem[i];
            }
        } catch (e) { /* some props throw getter errors */
        }
    }
    // Copy attributes
    for (i = 0; i < attrLen; i++) {
        newElem.setAttribute(attr[i].nodeName, attr[i].nodeValue);
    }
    // Copy inline CSS
    newElem.style.cssText = elem.style.cssText;
    return newElem;
}
function uuid() {
    var uuidValue = null;
    if (isBB10) {
        return appId + "-" + blackberry.identity.uuid;
    } else if (thisPhoneType == buzzerapps.phoneType.BB_TOUCH || thisPhoneType == buzzerapps.phoneType.BB_WEB) {
        uuidValue = blackberry.identity.IMEI;
    } else {
        uuidValue = device.uuid;
    }
    return appId + "-" + uuidValue;
}
function hookUpImageClicks(element, value) {
    if ($(element)[0].outerHTML.indexOf('touchEndHandler') == -1) {
        $(element).bind('click', function(event) {
            touchEndHandler(this);
        });
    }
    if (value.indexOf("Panel_GameDetails") > 0) {
        value = value.replace("OptionDialog:", "");
        options = value.split(")");
        for (var index = 0; index < options.length; index++) {
            var option = options[index];
            if (option.indexOf("Panel_GameDetails") == 0) {
                value = option;
                break;
            }
        }
    }
    if (value.indexOf("OptionDialog") >= 0) {
        $(element).parent().attr("ontapped", "showOptionDialog( \"" + value + "\" )");
    } else {
        $(element).attr("ontapped", "clickedImageListItem( \"" + value + "\" )");
    }
}

var isScrolling = false;
function touchMoveHandler(sourceElement) {
    isScrolling = true;
}

function touchEndHandler(sourceElement) {
    if (!event.cancelable || isScrolling) {
        isScrolling = false;
        return;
    }

    try {
        var command = sourceElement.attributes.ontapped.value;
        command = command.replace(/this/g, "sourceElement");
        clickDownAnimate(sourceElement, true);
        eval(command);
        event.preventDefault();
        event.cancelBubble = true;
    } catch (e) {
        // alert(e);
    }
}
function showOptionDialog(value) {
    optionDialog(value);
    $("#optionDialog").fadeIn(0);
}
function closeOptionDialog() {
    event.preventDefault();
    event.cancelBubble = true;
    event.stopPropagation();
    $('#optionDialog').fadeOut(0);
}
function optionDialog(value) {
    console.log(value);
    value = value.replace("OptionDialog:", "");
    // TODO: change the ontapped value of the parent div
    options = value.split(")");
    // Panel_GameDetails|Get:GetGameDetail.aspx?nostrip=1&amp;competitionId=%selectedCellRowId%
    for (var index = 0; index < options.length; index++) {
        var option = options[index];
        // AddToCal:Rochester vs Buffalo_2014-05-17 07:30 pm(Add to Calendar
        optionDetails = option.split("(");
        if (optionDetails[0].indexOf("Panel_GameDetails") == 0) {
            // Should never come here because
        } else if (optionDetails[0].indexOf("AddToCal:") == 0) {
            var optionparts = optionDetails[0].replace("AddToCal:", "");
            var messageTime = optionparts.split("_");
            var title = optionDetails[1];
            var message = messageTime[0];
            var gameTime = moment(messageTime[1], "YYYY-MM-DD hh:mm a"); // 2014-09-10
            // 07:30
            // pm
            var endTime = moment(messageTime[1], "YYYY-MM-DD hh:mm a");
            endTime = endTime.add(3, "hours");
            $("#optionTitle").text(title);
            $("#optionItem").html(message + "<br/>" + gameTime.format("MMMM Do YYYY, h:mm:ss a"));
            if (isBB10) {
                $("#optionItem").off();
                $("#optionItem").click(function() {
                    try {
                        createEventBB10(message, gameTime.toDate(), endTime.toDate());
                    } catch (e) {
                        console.log("Calendar.createEvent Error: " + e);
                    }
                    event.preventDefault();
                    event.cancelBubble = true;
                    event.stopPropagation();
                    closeOptionDialog();
                });
            } else {
                $("#optionItem").off();
                $("#optionItem").click(
                        function() {
                            try {
                                window.plugins.calendar.createEventInteractively(message, null, message, gameTime.toDate(), endTime.toDate(), null,
                                        function(a, b) {
                                            console.log("Calendar.createEvent success: " + a + " : " + b)
                                        }, function(a, b) {
                                            console.log("Calendar.createEvent success: " + a + " : " + b)
                                        });
                            } catch (e) {
                                console.log("Calendar.createEvent Error: " + e);
                            }
                            closeOptionDialog();
                        });
            }
        }
    }
    // Panel_GameDetailsSchedule(Box Score)AddToCal:Rochester vs
    // Calgary_2014-05-31 08:00 pm(Add to Calendar
    // AddToCal:Rochester vs Buffalo_2014-05-17 07:30 pm(Add to Calendar
}
function clickedImageListItem(value) {
    if (value.indexOf("http") == 0 || value.indexOf("rtsp") == 0) {
        switch (thisPhoneType) {
        case buzzerapps.phoneType.BB_TOUCH:
            if (isBB10) {
                blackberry.invoke.invoke({
                    target : "sys.browser",
                    uri : value
                }, null, null);
            } else {
                var args = new blackberry.invoke.BrowserArguments(value);
                blackberry.invoke.invoke(blackberry.invoke.APP_BROWSER, args);
            }
            break;
        case buzzerapps.phoneType.ANDROID:
            navigator.app.loadUrl(value, {
                openExternal : true
            });
            break;
        case buzzerapps.phoneType.BB_WEB:
            var args = new blackberry.invoke.BrowserArguments(value);
            blackberry.invoke.invoke(blackberry.invoke.APP_BROWSER, args);
            break;
        default:
            break;
        }
    } else {
        clickDownAnimate(this);
        if (isLeague) {
            if (value.indexOf("getPSTLeagueTeams") > 0) {
                if (value.indexOf("search=%TeamsSearchText_Temp%") > 0) {
                    initTopTeamChangePanel();
                }
                grabTeamChangeXML = true;
            }
        }
        submitForm(null, value);
    }
}
function initPageNonLeague() {
    jsLoad();
    if (!isBB10 && thisPhoneType == buzzerapps.phoneType.BB_TOUCH || thisPhoneType == buzzerapps.phoneType.BB_WEB) {
        initMenus();
    }
    if (thisPhoneType != buzzerapps.phoneType.BB_WEB) {
        $("div[id^=scrollerTable]").each(function(index) {
            if ($(this).attr("id") == "scrollerTable_Login" || $(this).attr("id") == "scrollerTable_CheckIn") {
                // TODO: remove any scrolling JavaSCript
            } else {
                /*
                 * $(this).on("touchstart", function(event) { // Prevent scrolling on this element event.preventDefault(); });
                 */
            }
        });
    }
    window.setInterval("rotationExec();", 5000);
    if (thisPhoneType == buzzerapps.phoneType.BB_WEB) {
        document.getElementById("wrapper").style.display = "block";
    }
    document.getElementById("contentPanel").style.display = "block";
    if (sport != "" && sport != "MLB" && sport != "NFL" && sport != "NBA" && sport != "NHL") {
        if (document.getElementById("Image_Status") != null) {
            var r = Math.floor(Math.random() * 1000000);
            var oldUrl = document.getElementById("Image_Status").style.background; // &w=320&h=19")
            var additional = "";
            if (oldUrl.indexOf("w=") != -1) {
                additional = oldUrl.substring(oldUrl.indexOf("w="));
                additional = "&" + additional.substring(0, additional.indexOf('"'));
            }
            var height = Math.floor((contentWidth / 320) * 19);
            document.getElementById("Image_Status").style.background = "url(" + apiUrl + "GetImage.aspx?type=status&format=jpg&id=" + appId
                    + "&lang=english&r=" + r + "&w=" + contentWidth + "&h=" + height + ")";
            document.getElementById("Image_Status").style.zIndex = "1";
        }
    }
    /*
     * var Panel_Login = document.getElementById("Panel_Login"); if (Panel_Login != null) { Panel_Login.style.zIndex = 999999; }
     */
    if (truncateHeight != 0) {
        document.getElementById("contentPanel").style.height = parseInt(screenHeight - truncateHeight) + "px";
    }
}
var ignorBackground = {};
function fixTemplates() {
    if (appId != 602 && appId != 600 && appId != 605 && appId != 601 && appId != 501 && !isBB10) {
        clearBackground("Image_MatchupsDate", "#6f6f6f");
        clearBackground("Image_Matchups", "#3c3c3c");
        clearBackground("TableRow_Matchups", "#3c3c3c");
        clearBackground("TableRow_MatchupsDate", "#3c3c3c");
        clearBackground("Label_Status", "transparent");
        clearBackground("Image_Scoreback", "black");
        $("#Image_Matchups").remove();
        $("#Image_MatchupsDate").css("border", "outset 4px #6f6f6f");
        $("#Label_Status").css("border-left", "ridge 4px #6f6f6f");
        $("#TableRow_Matchups").css("border-top", "groove 4px #3c3c3c");
    }
}
function clearBackground(elementId, color) {
    ignorBackground[elementId] = true;
    $("#" + elementId).css("backgroundImage", "").css("backgroundColor", color);
}
function processBackgroundImage(element, value) {
    if (ignorBackground[element.id] == undefined) {
        kids[i].style.backgroundImage = "url(" + value + ")";
    }
}
function updateTemplate(xml, url, interval) {
    var debug = false;
    if (url.indexOf("CalendarControl") != -1) {
        debug = true;
    }
    if (isLeague && grabTeamChangeXML) {
        if (url.indexOf("getPSTLeagueTeams") != -1) {
            teamPicked(xml, url);
            grabTeamChangeXML = false;
        }
    }
    if (isLeague) {
        if (url.indexOf("getPSTLeagueTeams") != -1) {
            $("div[id^=TableRow_ChangeTeamDivision\\~]").remove();
            $("div[id^=TableRow_ChangeTeamTeam\\~]").remove();
        }
    }
    var xmlDoc = null;
    deleteOrphenClones();
    try { // Internet Explorer
        xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
        xmlDoc.async = "false";
        xmlDoc.loadXML(xml);
    } catch (e) {
        try { // Firefox, Mozilla, Opera, etc.
            parser = new DOMParser();
            xmlDoc = parser.parseFromString(xml, "text/xml");
        } catch (e) {
            // alert(e.message)
        }
    }
    if (url != null) {
        cacheXml(url, xml);
    }
    try {
        var debugOutput = false;
        var yPos = 0;
        var height;
        var tableRow = null;
        var parentOfTemplateNodeId;
        var firstTime = true;
        var removeTemplates = true;
        var rotateCells = "0";
        var rotateCount = 0;
        var length = xmlDoc.documentElement.childNodes.length;
        var ids = "";
        var rowIndex = 0;
        var templateFound = null;
        var tableName = null;
        nextGameRowId = "0";
        var lastGameRowId = "0";
        for (var t = 0; t < xmlDoc.documentElement.childNodes.length; t++) {
            if (xmlDoc.documentElement.childNodes[t].attributes != null) {
                var recordDate = xmlDoc.documentElement.childNodes[t].attributes[0].nodeValue; // .attributes.getNamedItem("recordDate").nodeValue
                var updateDate = xmlDoc.documentElement.childNodes[t].attributes[1].nodeValue; // .attributes.getNamedItem("updateDate").nodeValue
                var rowId = xmlDoc.documentElement.childNodes[t].attributes[2].nodeValue; // .attributes.getNamedItem("rowId").nodeValue
                var doOnceSize = false;
                for (var y = 0; y < xmlDoc.documentElement.childNodes[t].childNodes.length; y++) {
                    if (xmlDoc.documentElement.childNodes[t].childNodes[y].attributes != null) {
                        var key = "";
                        var field = "";
                        var value = "";
                        try {
                            key = xmlDoc.documentElement.childNodes[t].childNodes[y].attributes[0].nodeValue; // .attributes.getNamedItem("key").nodeValue
                            field = xmlDoc.documentElement.childNodes[t].childNodes[y].firstChild.nodeName; // .firstChild.nodeName
                            if (key == "template") {
                                value = xmlDoc.documentElement.childNodes[t].childNodes[y].firstChild.nodeValue; // .firstChild.text;
                                templateFound = value;
                            } else {
                                try {
                                    value = xmlDoc.documentElement.childNodes[t].childNodes[y].firstChild.childNodes[0].nodeValue; // .firstChild.text;
                                } catch (e) {
                                    value = "";
                                }
                            }
                            if (value == "Panel_Headlines") {
                                value = "TableRow_HeadlineDetail";
                            }
                            if (value.indexOf("Panel_") != -1) {
                                removeTemplates = false;
                            }
                            if (key == "template") {
                                if (templates[value] == null) {
                                    // debug("key: " + key + " field: " + field
                                    // + " value: " + value);
                                    var origTemplate = document.getElementById(value); // document.getElementsByName(value)[0];
                                    // debug("origTemplate: " + origTemplate,
                                    // debugOutput);
                                    var height = parseInt(origTemplate.style.height, 10);
                                    parentOfTemplateNodeId = origTemplate.parentNode.id;
                                    rotateCellsDiv = document.getElementById("rotateCells" + parentOfTemplateNodeId);
                                    if (rotateCellsDiv != null) {
                                        rotateCells = rotateCellsDiv.value;
                                        if (rotateCells != "0") {
                                            delete rotation;
                                            rotation = new Array();
                                            rotationCounter = 0;
                                        }
                                    }
                                    // debug("adding to templates: " +
                                    // parentOfTemplateNodeId + " >>> " + value
                                    // + " rotateCells: " + rotateCells,
                                    // debugOutput);
                                    var temp = new template(origTemplate.id, cloneNodeOverride(origTemplate), parentOfTemplateNodeId, height);
                                    templates[value] = temp;
                                    if (removeTemplates) {
                                        origTemplate.parentNode.removeChild(origTemplate);
                                        // debug("Removing from DOM: " +
                                        // parentOfTemplateNodeId + " >>> " +
                                        // origTemplate.id, debugOutput);
                                    } else {
                                        origTemplate.style.display = "none";
                                    }
                                }
                                var origTemplate = templates[value].node;
                                if (tableName == null) {
                                    tableName = templates[value].parentNodeId;
                                    if (document.getElementById("loading" + tableName) != null) {
                                        document.getElementById("loading" + tableName).style.display = "none";
                                    }
                                    if (document.getElementById("scroller" + tableName) != null) {
                                        tableVisibleHeight[tableName] = parseInt(document.getElementById("scroller" + tableName).style.height, 10);
                                        // //console.log( tableName + " " +
                                        // tableVisibleHeight[ tableName ] );
                                    }
                                }
                                // alert(value + " " +
                                // templates[value].parentNodeId);
                                parentOfTemplateNodeId = templates[value].parentNodeId;
                                height = templates[value].height;
                                document.getElementById(parentOfTemplateNodeId).style.top = "0px";
                                // debug("orig node from templates: " +
                                // origTemplate.id + " yPos: " + yPos);
                                tableRow = cloneNodeOverride(origTemplate);
                                // This was added to keep the matchup list items
                                // from stacking over each other.
                                if (appId == 600 || appId == 601 || appId == 605 || appId == 501 || isBB10) {
                                    tableRow.style.top = yPos + "px";
                                } else {
                                    if (tableRow.id.indexOf("TableRow_Matchups") == 0
                                            || (thisPhoneType == buzzerapps.phoneType.BB_WEB && tableRow.id.indexOf("TableRow_liveMessage") == 0)) {
                                        tableRow.style.top = "0px";
                                    } else {
                                        tableRow.style.top = yPos + "px";
                                    }
                                }
                                tableRow.style.display = "block";
                                tableRow.childNodes[0].value = rowId;
                                tableRow.id = tableRow.id + "~" + rowId;
                                // tableRow.title = tableRow.id;
                                if (ids != "") {
                                    ids += "|";
                                }
                                ids += (rowId + "~" + rowIndex + "~" + height + "~" + tableRow.id);
                                rowIndex++;
                            } else {
                                var kids = null;
                                if (tableRow.id.indexOf("TableRow_liveMessageTemplate") == 0) {
                                    kids = $(tableRow).find("*[id]");
                                } else {
                                    kids = tableRow.childNodes;
                                }
                                if (tableRow.id.indexOf("TableRow_HeadlineDetail") != -1 && !doOnceSize) {
                                    // window.setTimeout("resizeNews('" +
                                    // tableRow.id + "');",0);
                                    doOnceSize = true;
                                }
                                if (rotateCount == 0 || rotateCells == "0") {
                                    tableRow.style.display = "block";
                                } else {
                                    tableRow.style.display = "none";
                                }
                                try {
                                    for (var i = 0; i < kids.length; i++) {
                                        var thisId = kids[i].id;
                                        if (thisId != null && thisId.indexOf("~") != -1) {
                                            thisId = thisId.substring(0, thisId.indexOf("~"));
                                        }
                                        if (thisId == key) {
                                            if (kids[i].id.indexOf("~") == -1 && rowId != "99999999") {
                                                kids[i].id = kids[i].id + "~" + rowId;
                                            }
                                            if (kids[i].nodeName == "IFRAME") {
                                                if (url != null && url != ".") {
                                                    if (field == "url" || field == "text") {
                                                        kids[i].src = value;
                                                    }
                                                }
                                            } else if (kids[i].nodeName == "IMG") {
                                                if (value != "" && value != ".") {
                                                    if (field == "url" && url != null) {
                                                        if (value.indexOf("http") != 0) {
                                                            if (value.indexOf(".aspx") != -1) {
                                                                value = apiUrl + value;
                                                            } else {
                                                            }
                                                        }
                                                        if (value.indexOf("&") != -1) {
                                                            value += "&width=" + parseInt(kids[i].style.width, 10);
                                                        }
                                                        kids[i].src = value.replace("local/", imagePath + "/");
                                                        kids[i].style.display = "block";
                                                    } else if (field == "onClick") {
                                                        hookUpImageClicks(kids[i], value);
                                                    } else if (field == "selected") {
                                                        kids[i].style.backgroundRepeat = "no-repeat";
                                                        kids[i].style.backgroundPosition = "";
                                                        if (value == "True") {
                                                            kids[i].src = kids[i].src.replace("unSelect", "select");
                                                        }
                                                    }
                                                } else if (field != "onClick" && field != "selected") {
                                                    kids[i].style.display = "none";
                                                }
                                            } else {
                                                if (value == "0.00") {
                                                    value = "";
                                                }
                                                // CheckBox_Dislike selected
                                                // False
                                                if (field == "textColor") {
                                                    kids[i].style.color = rgbConvert("(" + value + ")");
                                                } else {
                                                    // console.log(field + " " +
                                                    // value );
                                                    if (key.indexOf("Label_Location") != -1) {
                                                        while (value.indexOf(" ") != -1) {
                                                            value = value.replace(" ", "&nbsp;");
                                                        }
                                                    }
                                                    if (field == "url") {
                                                        // http://api.buzzerapps.com/webversion/local/logo133073.png?w=48&h=48
                                                        if (value.indexOf("http") != 0) {
                                                            if (value.indexOf(".aspx") != -1) {
                                                                value = apiUrl + value;
                                                            } else {
                                                                if (value.indexOf("local_") == 0) {
                                                                    value = rootUrl + value;
                                                                } else if (value.indexOf(imagePath) == -1) {
                                                                    value = value.replace("local", imagePath);
                                                                }
                                                            }
                                                        }
                                                        var thisWidth = parseInt(kids[i].style.width, 10);
                                                        var thisHeight = parseInt(kids[i].style.height, 10);
                                                        if (value.indexOf("w=") == -1) {
                                                            if (value.indexOf("?") != -1 || value.indexOf("?url") != -1) {
                                                                value += "&w=" + thisWidth + "&h=" + thisHeight;
                                                            } else {
                                                                value += "?w=" + thisWidth + "&h=" + thisHeight;
                                                            }
                                                        } else {
                                                            if (value.indexOf("?w=") != -1) {
                                                                value = value.replace("?w=", "?wx=");
                                                                value = value.replace("&h=", "&hx=");
                                                                value += "?w=" + thisWidth + "&h=" + thisHeight;
                                                            } else {
                                                                value = value.replace("&w=", "&wx=");
                                                                value = value.replace("&h=", "&hx=");
                                                                value += "&w=" + thisWidth + "&h=" + thisHeight;
                                                            }
                                                        }
                                                        kids[i].style.backgroundImage = "url(" + value + ")";
                                                    } else if (field == "onClick") {
                                                        hookUpImageClicks(kids[i], value);
                                                    } else if (field == "selected") {
                                                        kids[i].style.backgroundRepeat = "no-repeat";
                                                        kids[i].style.backgroundPosition = "";
                                                        if (value == "True") {
                                                            var thisBack = kids[i].style.backgroundImage.replace("unSelect", "select");
                                                            kids[i].style.backgroundImage = thisBack;
                                                        }
                                                    } else if (key.indexOf("TextBox_") != -1) {
                                                        kids[i].value = value;
                                                    } else {
                                                        kids[i].innerHTML = value;
                                                    }
                                                    if (kids[i].tagName != "SPAN") {
                                                        kids[i].style.display = "block";
                                                    } else {
                                                        kids[i].style.display = "inline";
                                                    }
                                                }
                                                lastGameRowId = rowId;
                                                if (nextGameRowId == "0" && url.indexOf("GetCoversSchedule") != -1 && key == "Label_HomeScore"
                                                        && field == "text" && value != null && value != "") {
                                                    nextGameRowId = rowId;
                                                }
                                            }
                                            break;
                                        }
                                    }
                                } catch (e) {
                                }
                            }
                        } catch (e) {
                            // alert("key: " + key + " field: " + field + "
                            // value: " + value);
                        }
                    }
                }
                var parentNode = document.getElementById(parentOfTemplateNodeId);
                if (tables[parentOfTemplateNodeId] != null && firstTime && removeTemplates) {
                    firstTime = false;
                    removeChildrenFromNode(parentNode);
                    if (document.getElementById("scrollbar" + parentOfTemplateNodeId) != null) {
                        document.getElementById("scrollbar" + parentOfTemplateNodeId).style.display = "none";
                    }
                }
                var parentNode = document.getElementById(parentOfTemplateNodeId);
                parentNode.appendChild(tableRow);
                if (parentNode.parentNode.id.indexOf("scroll") != -1) {
                    parentNode.style.height = yPos + height;
                    parentNode.style.top = "0px"; // /have to look at yet when
                    // jumping to row
                }
                if (rotateCells != "0") {
                    rotation[rotation.length] = tableRow.id;
                } else {
                    yPos += height;
                }
                if (url != null) {
                    tableRow.style.zIndex = UpUp;
                    UpUp++;
                } else {
                    tableRow.style.zIndex = -1;
                }
                rotateCount++;
            }
        }
        if (tables[parentOfTemplateNodeId] == null) {
            tables[parentOfTemplateNodeId] = true;
        }
        try {
            countLoads++;
            // //console.log(countLoads, true);
            if (countLoads > showApp) {
                countLoads = -10000;
                document.getElementById("contentPanel").style.display = "block";
                if (phoneType == "none") {
                    document.getElementById("splashScreen").style.display = "none";
                }
                // parent.showContents();
            }
        } catch (e) {
        }
        $(function() {
            var totalHeight = 0;
            $("#" + parentOfTemplateNodeId).children().each(function() {
                totalHeight += $(this).height();
            });
            tableContentHeight[parentOfTemplateNodeId] = totalHeight;
        });
        if (tableRowIds[parentOfTemplateNodeId] != null) {
            delete tableRowIds[parentOfTemplateNodeId];
        }
        tableRowIds[parentOfTemplateNodeId] = ids;
    } catch (e) {
        // alert(e.description + " " + url);
    }
    if (url != null && url.indexOf("GetCoversSchedule") != -1) {
        if (nextGameRowId == "0") {
            nextGameRowId = lastGameRowId;
        }
        try {
            document.getElementById("TableRow_Schedule~" + nextGameRowId).scrollIntoView(true);
        } catch (e) {
        }
        try {
            document.getElementById("TableRow_ScheduleImage~" + nextGameRowId).scrollIntoView(true);
        } catch (e) {
        }
        /*
         * submitForm(null, "JumpToRow:TableRow_Schedule"); submitForm(null, "JumpToRow:TableRow_ScheduleImage");
         */
    }
    if (url != null && url.indexOf("GetLoginPanel") != -1) {
        document.getElementById("TextBox_Login~101").addEventListener('keydown', loginKeypress, false);
        document.getElementById("TextBox_Login~102").addEventListener('keydown', loginKeypress, false);
    }
}
function loginKeypress() {
    if (event.keyCode == 13) {
        event.preventDefault();
        eval($("#Image_LoginButton").attr("ontapped"));
    }
}
function switchSubApp(newId) {
    if (newId == subAppId) {
        return;
    }
    // stop all current threads
    for (var int = 0; int < callbacks.length; int++) {
        window.clearTimeout(callbacks[int]);
    }
    callbacks = [];
    loadedContent = new Object();
    for (var int = 0; int < runningThreads.length; int++) {
        window.clearInterval(runningThreads[int]);
    }
    runningThreads = [];
    subAppId = newId;
    window.localStorage.setItem("subAppId" + appId, subAppId);
    updateAppIdUrlTrailer();
    // clear the tables.
    for ( var tableName in tables) {
        if (tableName.indexOf("Table_Ad") == -1 && tableName.indexOf("Table_Headlines") == -1) {
            $("#" + tableName).empty();
        } else {
            // console.log("Skipping:", tableName);
        }
    }
    rotation = new Array();
    rotationCounter = 0;
    startedOtherThreads = false;
    startedAdThreads = false;
    // start up the threads again.
    processStartThreadsHome();
    // processStartThreadsOthers();
    $("#Panel_ChangeTeam").hide();
    executeClickTouch("Tab_Home");
    /*
     * window.setTimeout(function() { console.log("Updating current teams");
     * loadxml("http://api.buzzerapps.com/admin/getPSTLeagueRecentTeams.aspx?a=1&"); }, 100);
     */
    return;
}
function updateAppIdUrlTrailer() {
    var tmpSubAppId = window.localStorage.getItem("subAppId" + appId);
    if (tmpSubAppId == "" || tmpSubAppId == null) {
        return;
    }
    // Set up new sub app id
    if (appIdtrailer.indexOf("subAppId") != -1) {
        updateParamValue("subAppId", tmpSubAppId);
    } else {
        appIdtrailer += "&subAppId=" + tmpSubAppId;
    }
}
var teamPickXmlStack = [];
var grabTeamChangeXML = false;
function hookupTeamPickerBack() {
    var changeTeamClose = $("#Image_ChangeTeamClose");
    changeTeamClose.removeAttr("ontapped");
    changeTeamClose.removeAttr("ontouchend");
    changeTeamClose.removeAttr("onclick");
    changeTeamClose.bind('click', teamPickedBack);
}
function teamPickedBack() {
    if (teamPickXmlStack.length > 1) {
        // remove the top xml from the change teams
        teamPickXmlStack.pop();
        // TODO: clear the table
        // load the top xml into the table
        var tmpObj = teamPickXmlStack[teamPickXmlStack.length - 1];
        updateTemplate(tmpObj.xml, tmpObj.url, null);
    }
    if (teamPickXmlStack.length < 2) {
        $("#Image_ChangeTeamClose").hide();
    }
}
function teamPicked(xml, url) {
    // TODO: may need to clear subAppId when selecting new team
    var tmpSubAppId = window.localStorage.getItem("subAppId" + appId);
    if (subAppId == "") {
        teamPickXmlStack.push({
            xml : xml,
            url : url
        });
    }
    if (teamPickXmlStack.length > 1) {
        $("#Image_ChangeTeamClose").show();
    } else {
        $("#Image_ChangeTeamClose").hide();
    }
}
function updateParamValue(param, value) {
    var params = appIdtrailer.split("&");
    for (var index = 0; index < params.length; index++) {
        var curParm = params[index];
        if (curParm.indexOf(param) == 0) {
            params[index] = param + "=" + value;
        }
    }
    appIdtrailer = params.join("&");
}
function initPageLeague() {
    jsLoad();
    if (!isBB10 && thisPhoneType == buzzerapps.phoneType.BB_TOUCH || thisPhoneType == buzzerapps.phoneType.BB_WEB) {
        initMenus();
    }
    var divs = document.getElementsByTagName("div");
    for (var i = 0; i < divs.length; i++) {
        if (divs[i].id.indexOf("scrollerTable") != -1) {
            divs[i].ontouchstart = function(event) {
                // Prevent scrolling on this element
                // event.preventDefault();
            };
        }
    }
    window.setInterval("rotationExec();", 5000);
    //
    document.getElementById("contentPanel").style.display = "block";
    if (document.getElementById("Image_Status") != null) {
        var r = Math.floor(Math.random() * 1000000);
        var oldUrl = document.getElementById("Image_Status").style.background; // &w=320&h=19")
        var additional = "";
        if (oldUrl.indexOf("w=") != -1) {
            additional = oldUrl.substring(oldUrl.indexOf("w="));
            additional = "&" + additional.substring(0, additional.indexOf('"'));
        }
        document.getElementById("Image_Status").style.backgroundImage = "url(" + apiUrl + "GetImage.aspx?type=status&format=jpg&id=" + appId
                + "&lang=english&r=" + r + "&w=320&h=19)";
        document.getElementById("Image_Status").style.zIndex = "1";
    }
    // subAppId get set in presetup
    if (subAppId == "") {
        initTopTeamChangePanel();
    }
    var Panel_Login = document.getElementById("Panel_Login");
    if (Panel_Login != null) {
        Panel_Login.style.zIndex = 999999;
    }
    if (truncateHeight != 0) {
        document.getElementById("contentPanel").style.height = parseInt(screenHeight - truncateHeight) + "px";
    }
}
function initTopTeamChangePanel() {
    subAppId = "";
    submitForm(null, "Show:Panel_ChangeTeam");
    grabTeamChangeXML = true;
    teamPickXmlStack = [];
    if (appId == 10000) {
        loadxml(apiUrl + "getPST5050Venues.aspx?level=0", 1);
    } else {
        loadxml(apiUrl + "getPSTLeagueTeamsWS.aspx?search=%TeamsSearchText_Temp%", 1);
    }
    window.setTimeout("document.getElementById('Image_ChangeTeamClose').style.display = 'none';", 0);
}
function startWatchingGeoPosition() {
    if (navigator.geolocation !== null) {
        var gpsOptions = {
            enableHighAccuracy : true,
            timeout : 10000,
            maximumAge : 300000
        }
        navigator.geolocation.getCurrentPosition(showPosition, geolocationError, gpsOptions);
        navigator.geolocation.watchPosition(showPosition);
    }
}
function geolocationError(error) {
    // TODO: BB10 will always error out
    // alert("An unexpected error occurred [" + error.code + "]: " +
    // error.message);
}
function showPosition(position) {
    latitude = position.coords.latitude;
    longitude = position.coords.longitude;
    accuracy = position.coords.accuracy;
}
function onSaveSuccess(calendarEvent) {
    if (isBB10) {
        blackberry.ui.dialog.standardAskAsync("Saved to calendar", blackberry.ui.dialog.D_OK, dialogCallBack, {
            title : "Calendar"
        });
    } else {
        alert("Saved to calendar.");
    }
}
function onSaveError(error) {
    alert("Unable to save event to your calendar.");
}
function createEventBB10(summary, startTime, endTime) {
    calendar = blackberry.pim.calendar;
    var calendarEvent = calendar.createEvent({
        "summary" : summary,
        "start" : startTime,
        "end" : endTime,
    // if timezone is specified explicitly, then the times will be
    // for that particular timezone; otherwise, the times will be
    // for the current device timezone
    // "timezone": "America/New_York"
    });
    calendarEvent.save(onSaveSuccess, onSaveError);
}
function submitForm(obj, submitUrl) { // Run:SavePage.aspx|Close:Panel_CustomerCreate|Run:GetTableData.aspx?name=Table_CoverCustomerList
    if (inDragging || cancelNext) {
        cancelNext = false;
        return;
    }
    var parentNode = null;
    if (obj != null) {
        parentNode = obj.parentNode;
    }
    var actionElements = submitUrl.split("|");
    for (var a = 0; a < actionElements.length; a++) {
        actionElements[a] = actionElements[a].trim();
        var deets = actionElements[a].split(":");
        if (deets[0] == "PlaceHolder") {
        } else if (deets[0] == "ClearAndGet") {
            // deets[1]: "Table_Teams"
            loadxml(apiUrl + "getPSTLeagueTeamsWS.aspx?search=%TeamsSearchText_Temp%", 1);
        } else if (deets[0] == "SwitchSubApp") {
            switchSubApp(deets[1]);
            return;
            if (appIdtrailer.indexOf("subAppId") != -1) {
                appIdtrailer = appIdtrailer.replace(subAppId, deets[1]);
            } else {
                appIdtrailer += "&subAppId=" + deets[1];
            }
            subAppId = deets[1];
            var w = getQuerystring("w", null);
            var h = getQuerystring("h", null);
            var forwardUrl = rootUrl + "default.aspx?appId=" + appId + "&isMobile=1&lang=en&sport=" + sport + "&subAppId=" + subAppId;
            if (w != "") {
                forwardUrl += "&w=" + w + "&h=" + h;
            }
            document.location = forwardUrl;
            return;
        } else if (deets[0] == "LoadContent") {
            if (document.getElementById(deets[1]) == null || document.getElementById(deets[1]).innerHTML.indexOf("iframe") == -1) {
                var r = Math.floor(Math.random() * 1000000);
                var pageUrl = "LoadContent.aspx?lan=" + lan + "&id=" + deets[1] + "&r=" + r;
                cGet(apiUrl + pageUrl, true, "loadContentCallback", deets[1]);
            }
        } else if (deets[0] == "Get") { // Get:Table_LiveMessages&amp;maxRecords=25
            if (deets[1].indexOf(".aspx") == -1) {
                loadxml(apiUrl + "GetTableData.aspx?name=" + deets[1], 1);
            } else {
                if (deets[1].indexOf("%id%") != -1) {
                    deets[1] = deets[1].replace("%id%", lastRowId);
                }
                if (deets[1].indexOf("%selectedCellRowId%") != -1) {
                    deets[1] = deets[1].replace("%selectedCellRowId%", lastRowId);
                }
                loadxml(apiUrl + deets[1], 1);
            }
        } else if (deets[0] == "Post") { // Post:TagBuzz.aspx?tag=1&id=%rowId%
            // Post:PostComment.aspx?text=%TextBox_Message_F%
            // Post:PostBuzz.aspx?text=%Buzz_CurrentMessage%
            if (deets[1].indexOf("PostComment") != -1) {
                var commentObj = document.getElementById("TextBox_Message_F");
                if (commentObj != null) {// encodeURI(contents)
                    commentValue = encodeURI(commentObj.value);
                    deets[1] = deets[1].replace("%TextBox_Message_F%", commentValue);
                    var retVal = cGet(apiUrl + deets[1], false, null, null);
                    var message = retVal.substring(retVal.indexOf("<message>") + 9);
                    message = message.substring(0, message.indexOf("</message>"));
                    alert(message);
                }
                // Post:addUser.aspx?username=%Buzz_Username%
            } else if (deets[1].indexOf("PostBuzz") != -1) {
                var ver = deets[1].indexOf("v=1") != -1 ? "1" : "2";
                var usernameObj = document.getElementById("TextBox_BuzzCurrentMessage" + ver);
                if (usernameObj != null) {// encodeURI(contents)
                    usernameValue = encodeURI(usernameObj.value);
                    deets[1] = deets[1].replace("%Buzz_CurrentMessage%", usernameValue);
                    if (deets[1].indexOf("%id%") != -1) {
                        deets[1] = deets[1].replace("%id%", lastRowId);
                    }
                    var retVal = cGet(apiUrl + deets[1], false, null, null);
                    if (retVal.indexOf("<message>") != -1) {
                        var message = retVal.substring(retVal.indexOf("<message>") + 9);
                        message = message.substring(0, message.indexOf("</message>"));
                        alert(message);
                        return;
                    } else {
                        loadxml(apiUrl + "GetBuzz.aspx?maxRecords=25&ifChangedSince=01-01-2010", 1);
                        if (ver == "1") {
                            loadxml(apiUrl + "GetBuzz.aspx?parentId=" + lastRowId + "&maxRecords=25&ifChangedSince=01-01-2010", 1);
                        }
                    }
                }
                // <updateTable>Table_Messages</updateTable><updateTable>Table_LiveMessages</updateTable>
                // Post:addUser.aspx?username=%Buzz_Username%
            } else if (deets[1].indexOf("GetMealityId.aspx") != -1) {
                var TextBox_LoginName = document.getElementById("TextBox_Login~101");
                if (TextBox_LoginName != null) {// encodeURI(contents)
                    var TextBox_LoginNameValue = encodeURI(TextBox_LoginName.value);
                    deets[1] = deets[1].replace("%LoginName_value%", TextBox_LoginNameValue);
                }
                var TextBox_LoginPassword = document.getElementById("TextBox_Login~102");
                if (TextBox_LoginPassword != null) {// encodeURI(contents)
                    var TextBox_LoginPasswordValue = encodeURI(TextBox_LoginPassword.value);
                    deets[1] = deets[1].replace("%LoginPassword_Value%", TextBox_LoginPasswordValue);
                }
                var TextBox_LoginBarcode = document.getElementById("TextBox_Login~103");
                if (TextBox_LoginBarcode != null) {// encodeURI(contents)
                    var TextBox_LoginBarcodeValue = encodeURI(TextBox_LoginBarcode.value);
                    deets[1] = deets[1].replace("%LoginBarcode_value%", TextBox_LoginBarcodeValue);
                }
                var retVal = cGet(apiUrl + deets[1], false, null, null);
                var message = "";
                if (retVal.indexOf("<message>") != -1) {
                    message = retVal.substring(retVal.indexOf("<message>") + 9);
                    message = message.substring(0, message.indexOf("</message>"));
                }
                if (retVal.indexOf("<result>Error</result>") != -1) {
                    alert(message);
                } else {
                    submitForm(null, message);
                }
            } else if (deets[1].indexOf("GetSaveCredetials.aspx") != -1) {
                var TextBox_LoginName = document.getElementById("TextBox_Login~101");
                if (TextBox_LoginName != null) {// encodeURI(contents)
                    var TextBox_LoginNameValue = encodeURI(TextBox_LoginName.value);
                    deets[1] = deets[1].replace("%LoginName_value%", TextBox_LoginNameValue);
                }
                var TextBox_LoginPassword = document.getElementById("TextBox_Login~102");
                if (TextBox_LoginPassword != null) {// encodeURI(contents)
                    var TextBox_LoginPasswordValue = encodeURI(TextBox_LoginPassword.value);
                    deets[1] = deets[1].replace("%LoginPassword_Value%", TextBox_LoginPasswordValue);
                }
                var TextBox_LoginBarcode = document.getElementById("TextBox_Login~103");
                if (TextBox_LoginBarcode != null) {// encodeURI(contents)
                    var TextBox_LoginBarcodeValue = encodeURI(TextBox_LoginBarcode.value);
                    deets[1] = deets[1].replace("%LoginBarcode_value%", TextBox_LoginBarcodeValue);
                }
                var retVal = cGet(apiUrl + deets[1], false, null, null);
                var message = "";
                if (retVal.indexOf("<message>") != -1) {
                    message = retVal.substring(retVal.indexOf("<message>") + 9);
                    message = message.substring(0, message.indexOf("</message>"));
                }
                if (retVal.indexOf("<result>Error</result>") != -1) {
                    alert(message);
                } else {
                    submitForm(null, message);
                }
                // Post:CheckIn.aspx?section=%CheckIn_Section%&row=%CheckIn_Row%&seat=%CheckIn_Seat%&email=%CheckIn_Email%
            } else if (deets[1].indexOf("CheckIn") != -1) {
                var section = document.getElementById("TextBox_Section").value;
                var row = document.getElementById("TextBox_Row").value;
                var seat = document.getElementById("TextBox_Seat").value;
                var email = document.getElementById("TextBox_Email").value;
                deets[1] = deets[1].replace("%CheckIn_Section%", section);
                deets[1] = deets[1].replace("%CheckIn_Row%", row);
                deets[1] = deets[1].replace("%CheckIn_Seat%", seat);
                deets[1] = deets[1].replace("%CheckIn_Email%", email);
                var retVal = cGet(apiUrl + deets[1], false, null, null);
                var message = "";
                if (retVal.indexOf("<message>") != -1) {
                    message = retVal.substring(retVal.indexOf("<message>") + 9);
                    message = message.substring(0, message.indexOf("</message>"));
                    alert(message);
                }
            } else if (deets[1].indexOf("addUser") != -1) {
                var usernameObj = document.getElementById("TextBox_BuzzUsername");
                if (usernameObj != null) {// encodeURI(contents)
                    usernameValue = encodeURI(usernameObj.value);
                    deets[1] = deets[1].replace("%Buzz_Username%", usernameValue);
                    var retVal = cGet(apiUrl + deets[1], false, null, null);
                }
            } else if (deets[1].indexOf("addAlertEmail") != -1) {
                var usernameObj = document.getElementById("TextBox_EmailAddress~0");
                if (usernameObj != null) {// encodeURI(contents)
                    usernameValue = encodeURI(usernameObj.value);
                    deets[1] = deets[1].replace("%AlertEmailAddress%", encodeURIComponent(usernameValue));
                    var retVal = cGet(apiUrl + deets[1], false, null, null);
                    if (retVal.indexOf("<message>") != -1) {
                        retVal = retVal.substring(retVal.indexOf("<message>") + 9);
                        retVal = retVal.substring(0, retVal.indexOf("</message>"));
                        alert(retVal);
                    }
                }
            } else if (deets[1].indexOf("SetAlert") != -1) {
                var id = obj.id.substring(obj.id.indexOf("~") + 1);
                if (obj.id.indexOf("~") != -1) {
                    id = obj.id.substring(obj.id.indexOf("~") + 1);
                }
                if (deets[1].indexOf("%rowId%") != -1) {
                    deets[1] = deets[1].replace("%rowId%", id);
                }
                var retVal = cGet(apiUrl + deets[1], false, null, null);
                if (retVal.indexOf("OK") != -1) {
                    obj.style.backgroundRepeat = "no-repeat";
                    obj.style.backgroundPosition = "";
                    var backImage = obj.style.backgroundImage;
                    if (backImage.indexOf("/un") != -1) {
                        backImage = backImage.replace("/unSelect", "/select");
                    } else {
                        backImage = backImage.replace("/select", "/unSelect");
                    }
                    obj.style.backgroundImage = backImage;
                }
                // loadxml( apiUrl + "GetNotifications.aspx?a=1" ,1 );
                cancelNext = false;
                inDragging = false;
                // <data> <result>OK</result>
                // <updateTable>Table_Alert</updateTable></data>
            } else if (deets[1].indexOf("clearPSTLeagueTeamHistory") != -1) {
                var retVal = cGet(apiUrl + deets[1], false, null, null);
                $("#Panel_Live [id^=TableRow_]").remove();
                loadxml("http://api.buzzerapps.com/admin/getPSTLeagueRecentTeams2.aspx?a=1", -1);
            } else if (deets[1].indexOf("PostVote") != -1) {
                var id = obj.id.substring(obj.id.indexOf("~") + 1);
                if (obj.id.indexOf("~") != -1) {
                    id = obj.id.substring(obj.id.indexOf("~") + 1);
                }
                if (deets[1].indexOf("%rowId%") != -1) {
                    deets[1] = deets[1].replace("%rowId%", id);
                }
                var retVal = cGet(apiUrl + deets[1], false, null, null);
                if (retVal.indexOf("OK") != -1) {
                    obj.style.backgroundRepeat = "no-repeat";
                    obj.style.backgroundPosition = "";
                    var backImage = obj.style.backgroundImage;
                    if (backImage.indexOf("/un") != -1) {
                        backImage = backImage.replace("/unSelect", "/select");
                    } else {
                        backImage = backImage.replace("/select", "/unSelect");
                    }
                    obj.style.backgroundImage = backImage;
                }
                loadxml(apiUrl + "GetVote.aspx?a=1", 1);
                cancelNext = false;
                inDragging = false;
                // <data> <result>OK</result>
                // <updateTable>Table_Alert</updateTable></data>
            } else if (deets[1].indexOf("TagBuzz") != -1) {
                var ver = deets[1].indexOf("v=1") != -1 ? "1" : "2";
                var id = lastRowId;
                if (obj.id.indexOf("~") != -1) {
                    id = obj.id.substring(obj.id.indexOf("~") + 1);
                }
                if (deets[1].indexOf("%rowId%") != -1) {
                    deets[1] = deets[1].replace("%rowId%", id);
                }
                // alert(apiUrl + deets[1]); //<data> <result>OK</result>
                // <updateTable>Table_LiveMessages</updateTable></data>
                var retVal = cGet(apiUrl + deets[1], false, null, null);
                if (ver == "1") { // <updateTable>Table_LiveMessagesReply</updateTable>
                    loadxml(apiUrl + "GetBuzz.aspx?parentId=" + lastRowId + "&maxRecords=25&ifChangedSince=01-01-2010", 1);
                    loadxml(apiUrl + "GetBuzz.aspx?maxRecords=25&ifChangedSince=01-01-2010", 1);
                } else if (ver == "2") {
                    loadxml(apiUrl + "GetBuzz.aspx?maxRecords=25&ifChangedSince=01-01-2010", 1);
                }
                if (retVal.indexOf("<message>") != -1) {
                    retVal = retVal.substring(retVal.indexOf("<message>") + 9);
                    retVal = retVal.substring(0, retVal.indexOf("</message>"));
                    alert(retVal);
                }
            } else if (deets[1].indexOf("Table_") != -1) {
                if (deets[1].indexOf("Table_LiveMessagesReply") != -1) {
                    loadxml(apiUrl + "GetBuzz.aspx?parentId=" + lastRowId + "&maxRecords=25&ifChangedSince=01-01-2010", 1);
                } else if (deets[1].indexOf("Table_LiveMessages") != -1) {
                    loadxml(apiUrl + "GetBuzz.aspx?maxRecords=25&ifChangedSince=01-01-2010", 1);
                }
            }
        } else if (deets[0] == "Close") {
            var closeArray = deets[1].split(",");
            for (var s = 0; s < closeArray.length; s++) {
                closeForm(obj, closeArray[s]);
            }
        } else if (deets[0].indexOf("Iframe") != -1) {
            var id = obj.id.substring(obj.id.indexOf("~") + 1);
            if (deets[1].indexOf("%selectedCellRowId%") != -1) {
                deets[1] = deets[1].replace("%selectedCellRowId%", id);
            }
            document.getElementById(deets[0]).src = apiUrl + deets[1];
        } else if (deets[0] == "UnpushButtonsOnPanel") {
            if (document.getElementById(deets[1]) != null) {
                unpushButtonsOnPanel(document.getElementById(deets[1]))
            }
        } else if (deets[0] == "Click") {
            if (document.getElementById(deets[1]) != null) {
                simulateClick(deets[1]); // Click:Button_CustomerCreate
            }
        } else if (deets[0] == "CloseAllOpenPanels") {
            for ( var i in openPanels) {
                submitForm(null, "Close:" + i);
            }
            delete openPanels;
            openPanels = new Object();
        } else if (deets[0] == "Hide") { // Hide:Table_CoverCustomerLookup
            // console.log("in Hide: " +deets[1] );
            var elements = deets[1].split(",");
            for (var t = 0; t < elements.length; t++) {
                // console.log("hiding: " +elements[t] );
                var element = document.getElementById(elements[t]);
                if (element != null) {
                    element.style.display = "none";
                    // console.log("hiding: " +elements[t] );
                    if (groupHidePanels[elements[t]] != null) {
                        delete groupHidePanels[elements[t]];
                    }
                } else {
                    // alert("Hide: " + elements[t] + " not found");
                }
            }
        } else if (deets[0] == "HideAllGroup") {
            var hidable = "";
            for ( var id in groupHidePanels) {
                if (hidable != "") {
                    hidable += ",";
                }
                hidable += id;
            }
            if (hidable != "") {
                cancelNext = false;
                submitForm(null, "Hide:" + hidable);
            }
        } else if (deets[0] == "ShowParentOf") {
            var textId = null;
            if (deets[1] != "") {
                textId = deets[1];
            } else {
                textId = obj.innerHTML;
            }
            var element = document.getElementById(textId);
            if (element != null) {
                var parentElement = element.parentNode;
                var panel = document.getElementById("Panel_Search");
                if (panel != null) {
                    panel.style.display = "none";
                } else {
                    alert("ShowParentOf: Panel_Search not found");
                }
                cancelNext = false;
                submitForm(null, "Show:" + parentElement.id + "|LoadContent:" + textId);
            } else {
                alert("ShowParentOf: " + textId + " not found");
            }
        } else if (deets[0] == "GetPublicationdate") {
            var nameObj = document.getElementById("DropDown_Edit_OneOrderDetails_Newspaper");
            var paperId = nameObj.options[nameObj.selectedIndex].value;
            var TextBox_Edit_OneOrderDetails_RunDate = document.getElementById("TextBox_Edit_OneOrderDetails_RunDate");
            var runDate = TextBox_Edit_OneOrderDetails_RunDate.value;
            if (paperId != null && paperId != "") {
                var date = cGet(apiUrl + "GetPublicationdate.aspx?paperId=" + paperId + "&runDate=" + runDate, false, null, null);
                TextBox_Edit_OneOrderDetails_RunDate.value = date;
            }
        } else if (deets[0] == "Drill") {
            var options = deets[1].split("~");
            var pageLoad = options[1];
            loadxml(apiUrl + pageLoad, 1); // Drill:
            // Table_CalendarHeaderDays~CalendarControl.aspx?type=Calendar&month=07&year=2012
        } else if (deets[0] == "Show") {
            var fadeIn = false;
            var options = deets[1].split("~");
            if (options[1] == "true") {
                fadeIn = true;
            }
            var elements = options[0].split(",");
            for (var t = 0; t < elements.length; t++) {
                openPanels[elements[t]] = true;
                var element = document.getElementById(elements[t]);
                if (element != null) {
                    if (fadeIn) {
                        window.setTimeout("fadeIn('" + elements[t] + "', 1);", 0);
                    } else {
                        element.style.display = "block";
                    }
                    element.style.zIndex = UpUp;
                    UpUp++;
                    groupHidePanels[elements[t]] = true;
                } else {
                    alert("Show: " + elements[t] + " not found");
                }
            }
        } else if (deets[0] == "LoadDDLB") {
            // LoadDDLB:DropDown_Edit_DataEntryDetail_SalesRep~SalesReps~false~~
            // LoadDDLB:DropDown_Edit_OneEntryDetail_Clients~OneClients~false~Agency~DropDown_Edit_OneEntryDetail_Agency
            var elements = deets[1].split("~");
            var ddlb = document.getElementById(elements[0]);
            var fields = elements[2];
            var where = elements[3];
            var value = elements[4];
            if (ddlb != null) {
                populateDDLB(where == "" ? false : true, ddlb, elements[1], fields, where, value);
            }
        } else if (deets[0] == "ClearFields") { // ClearFields:TextBox_Edit_Regions~Rate,Words,Discount,Cost,Commission,GrossCost|ClearFields:DropDown_Edit_Regions~PlacementId
            var fields = deets[1].split(",");
            for (var z = 0; z < fields.length; z++) {
                if (fields[z].indexOf("TextBox_") != -1) {
                    var field = document.getElementById(fields[z]);
                    if (field != null) {
                        field.value = "";
                    } else {
                        alert("field doesn't exist: " + fields[z]);
                    }
                } else if (fields[z].indexOf("DropDown_") != -1) {
                    var field = document.getElementById(fields[z]);
                    if (field != null) {
                        field.selectedIndex = 0;
                    } else {
                        alert("field doesn't exist: " + fields[z]);
                    }
                } else if (fields[z].indexOf("CheckBox") != -1) {
                    var field = document.getElementById(fields[z]);
                    field.src = imagePath + "/unSelect.png";
                }
            }
        } else if (deets[0] == "GetUsername") {
            if (buzzUsername + "-" == "null-") {
                buzzUsername = "Username";
            }
            var usernameBox = document.getElementById(deets[1]);
            if (usernameBox != null) {
                usernameBox.value = buzzUsername;
            }
        } else if (deets[0] == "SetUsername") {
            var usernameBox = document.getElementById(deets[1]);
            if (usernameBox != null) {
                buzzUsername = usernameBox.value;
                try {
                    if (window.localStorage) {
                        window.localStorage.setItem("buzzUsername" + appId, buzzUsername);
                    }
                } catch (e) {
                }
            }
        } else if (deets[0] == "JumpToRow") {
            var rowId = nextGameRowId;
            var tableRowName = deets[1];
            var tableName = tableRowName.replace("Row", "");
            tableName = tableName.replace("Image", "");
            var schedRow = document.getElementById(tableRowName + "~" + rowId);
            if (schedRow != null) {
                var topOfRow = parseInt(schedRow.style.top, 10);
                var table_Schedule = document.getElementById(tableName);
                var table_ScheduleHeight = parseInt(table_Schedule.style.height, 10);
                var scrollerHeight = parseInt(table_Schedule.parentNode.style.height, 10);
                var tableRowHeight = parseInt(schedRow.style.height, 10);
                var topOfRowAdj = -topOfRow + (scrollerHeight / 2) - (tableRowHeight / 2);
                if (topOfRowAdj > 0) {
                    topOfRowAdj = 0;
                }
                if (table_Schedule != null) {
                    table_Schedule.style.top = topOfRowAdj + "px";
                }
            }
        } else if (deets[0].indexOf("http") == 0) {
            return;
        } else if (deets[0].indexOf("Panel_") != -1) {
            openPanel(obj, deets[0], null, null, null, false);
        } else {
            if (sport == "") {
                alert("unrec command: " + deets[0] + " " + submitUrl);
            }
        }
    }
    if (obj != null && obj.id.indexOf("CheckBox") != -1) {
        if (obj.id.indexOf("CheckBox_Dislike") != -1 || obj.id.indexOf("CheckBox_Like") != -1) {
            cancelNext = true;
        }
        return false;
    } else {
        return true;
    }
}
function cGet(url, async, callback, params) {
    if (url.indexOf("GetSubAppId.aspx") == -1) {
        url += appIdtrailer;
    }
    var req = false;
    // For Safari, Firefox, and other non-MS browsers
    if (window.XMLHttpRequest) {
        try {
            req = new XMLHttpRequest();
        } catch (e) {
            req = false;
        }
    } else if (window.ActiveXObject) {
        // For Internet Explorer on Windows
        try {
            req = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) {
            try {
                req = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {
                req = false;
            }
        }
    }
    if (req) {
        // Synchronous request, wait till we have it all
        if (async) {
            var randomnumber = Math.floor(Math.random() * 1000001);
            req.open("GET", url + "&r=" + randomnumber, true);
            req.send(null);
            // alert(url);
            req.onreadystatechange = function() {
                if (req.readyState == 4) {
                    if (callback == "loadPageCallback") {
                        loadPageCallback(req.responseText);
                    } else if (callback == "loadContentCallback") {
                        loadContentCallback(req.responseText, params);
                    } else {
                        alert("async: " + callback + " not supported");
                    }
                }
            }
        } else {
            var randomnumber = Math.floor(Math.random() * 1000001);
            req.open("GET", url + "&r=" + randomnumber, false);
            req.send(null);
            if (callback == "loadPageCallback") {
                loadPageCallback(req.responseText);
            } else {
                return req.responseText;
            }
        }
    }
}

function initPushwoosh() {
    var pushNotification = cordova.require("com.pushwoosh.plugins.pushwoosh.PushNotification");

    // set push notifications handler
    document.addEventListener('push-notification', function(event) {
        var title = event.notification.title;
        var userData = event.notification.userdata;

        if (typeof (userData) != "undefined") {
            console.warn('user data: ' + JSON.stringify(userData));
        }
        console.warn('push-notification: ' + JSON.stringify(userData));

        alert(title);
    });

    // initialize Pushwoosh with projectid: "GOOGLE_PROJECT_NUMBER", pw_appid : "PUSHWOOSH_APP_ID". This will trigger all pending push notifications
    // on start.
    pushNotification.onDeviceReady({
        projectid : "283286751259",
        pw_appid : "${PUSH_WOOSH_APPLICATION_ID}"
    });

    // register for pushes
    pushNotification.registerDevice(function(status) {
        var pushToken = status;
        console.warn('push token: ' + pushToken);
        appSync(pushToken);
    }, function(status) {
        console.warn(JSON.stringify([ 'failed to register ', status ]));
    });
}